'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var notifyResizeStyle = {
  position: 'absolute',
  top: 0,
  left: 0,
  width: '100%',
  height: '100%',
  zIndex: -1,
  overflow: 'auto',
  display: 'block',
  pointerEvents: 'none',
  opacity: 0
};

var NotifyResize = (function (_React$Component) {
  _inherits(NotifyResize, _React$Component);

  function NotifyResize(props) {
    _classCallCheck(this, NotifyResize);

    _get(Object.getPrototypeOf(NotifyResize.prototype), 'constructor', this).call(this, props);

    this.state = {
      resizeToolWidth: 0,
      resizeToolHeight: 0,
      notifyResizeWidth: 0,
      notifyResizeHeight: 0
    };

    this.checkResize = this.checkResize.bind(this);
  }

  _createClass(NotifyResize, [{
    key: 'render',
    value: function render() {
      var props = this.props;
      var Component = this.props.factory;

      var resizeTool = _react2['default'].createElement(
        'div',
        {
          ref: 'notifyResize',
          className: 'notifyResize',
          style: notifyResizeStyle,
          onScroll: this.checkResize
        },
        _react2['default'].createElement('div', {
          ref: 'resizeTool',
          className: 'resizeTool',
          style: {
            position: 'absolute',
            top: 0,
            left: 0,
            width: this.state.resizeToolWidth,
            height: this.state.resizeToolHeight
          }
        })
      );

      return _react2['default'].createElement(Component, _extends({}, props, {
        factory: null,
        resizeTool: resizeTool,
        ref: 'component'
      }));
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.resetResizeTool();
    }
  }, {
    key: 'getDimensions',
    value: function getDimensions() {
      var resizeTool = this.refs.resizeTool;
      var notifyResize = this.refs.notifyResize;

      return {
        resizeToolWidth: resizeTool.offsetWidth,
        resizeToolHeight: resizeTool.offsetHeight,
        notifyResizeWidth: notifyResize.offsetWidth,
        notifyResizeHeight: notifyResize.offsetHeight
      };
    }
  }, {
    key: 'resetResizeTool',
    value: function resetResizeTool() {
      // check if they are monted
      if (!this.refs.resizeTool && !this.refs.notifyResize) {
        console.error('For notifyResize to work you must render resizeTool from {props.resizeTool}');
        return false;
      }

      this.setDimensions();
      this.scrollToBottom();
    }
  }, {
    key: 'setDimensions',
    value: function setDimensions() {
      var _getDimensions = this.getDimensions();

      var notifyResizeWidth = _getDimensions.notifyResizeWidth;
      var notifyResizeHeight = _getDimensions.notifyResizeHeight;

      // Resize tool will be bigger than it's parent by 1 pixel in each direction
      this.setState({
        notifyResizeWidth: notifyResizeWidth,
        notifyResizeHeight: notifyResizeHeight,
        resizeToolWidth: notifyResizeWidth + 2,
        resizeToolHeight: notifyResizeHeight + 2
      });
    }
  }, {
    key: 'scrollToBottom',
    value: function scrollToBottom() {
      var _this = this;

      // so the scroll moves when element resizes

      if (this.refs.notifyResize) {
        setTimeout(function () {
          _this.refs.notifyResize.scrollTop = _this.refs.notifyResize.scrollHeight;
          _this.refs.notifyResize.scrollLeft = _this.refs.notifyResize.scrollWidth;
        }, 0);
      }
    }
  }, {
    key: 'checkResize',
    value: function checkResize() {
      var _getDimensions2 = this.getDimensions();

      var notifyResizeWidth = _getDimensions2.notifyResizeWidth;
      var notifyResizeHeight = _getDimensions2.notifyResizeHeight;

      if (notifyResizeWidth !== this.state.notifyResizeWidth || notifyResizeHeight !== this.state.notifyResizeHeight) {
        // reset resizeToolDimensions
        this.onResize();
        this.resetResizeTool();
      }
    }
  }, {
    key: 'onResize',
    value: function onResize() {
      if (this.props.onResize) {
        this.props.onResize();
      }

      if (this.refs.component.onResize) {
        this.refs.component.onResize();
      }
    }
  }]);

  return NotifyResize;
})(_react2['default'].Component);

NotifyResize.propTypes = {
  onResize: _react.PropTypes.func
};

var notifyResize = function notifyResize(Component) {
  return (function (_React$Component2) {
    _inherits(_class, _React$Component2);

    function _class() {
      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(_class, [{
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(NotifyResize, _extends({ factory: Component }, this.props));
      }
    }]);

    return _class;
  })(_react2['default'].Component);
};

exports['default'] = notifyResize;
exports.NotifyResize = NotifyResize;